<template>
    <div class="">
        <div class="table_config" v-if="on_load && this.page_index == 1">
            <div class="fakeloader">
                <div class="fl spinner4"></div>
            </div>
        </div>
        <div class="tb_ct mobile_ct" v-if="is_mobile">
            <table class="base_tb_ct">
                <tr v-if="!show_data.length">
                    <td colspan="2">
                        <div class="no_data">{{ lang.no_data }}</div>
                    </td>
                </tr>

                <template v-for="item, index in show_data" v-if="show_data.length">
                   <tr class="tr_bg">
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.transaction_id }}
                            </div>
                        </td>
                        <td>
                            <div class="td_more_show w_48">
                                <router-link class="blue_ft" :to="{name: 'transaction_detail_view', params: {trx_id: item.trx_id}}">{{ item.trx_id }}</router-link>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.contract_name }}
                            </div>
                        </td>
                        <td>
                            <div>
                                <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.account}}">{{ item.account }}</router-link>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.action_name }}
                            </div>
                        </td>
                        <td>
                            <div class="w_100">
                                {{ item.name }}
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.actor }}
                            </div>
                        </td>
                        <td>
                            <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.actor}}">{{ item.actor + '@' + item.permission }}</router-link>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.transfer_direction }}
                            </div>
                        </td>
                        <td>
                            <div class="w_150">
                                <template v-for="name, index in get_related_accounts(item)" v-if="name">
                                    <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: name}}">{{ name }}</router-link> 
                                    <span v-if="name && index < get_related_accounts(item).length - 1">-> </span>
                                </template>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.ammount }}
                            </div>
                        </td>
                        <td>
                            {{ item.quantity || '' }}
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="mobile_width_60">
                                {{ lang.commont }}
                            </div>
                        </td>
                        <td>
                            {{ get_action_ob(item).data.memo }}
                        </td>
                    </tr>

                </template>
            </table>
        </div>
        <div class="tb_ct pc_module">
            <table class="base_tb_ct" v-if="!on_load || (on_load && this.page_index > 1)">
                <thead>
                    <tr>
                        <th>
                            {{ lang.transaction_id }}
                        </th>
                        <th>
                            {{ lang.contract_name }}
                        </th>
                        <th>
                            {{ lang.action_name }}
                        </th>
                        <th>
                            {{ lang.transaction_time }}
                        </th>
                        <th>
                            {{ lang.block_num }}
                        </th>
                        <th>
                            {{ lang.actor }}
                        </th>
                        <th>
                            {{ lang.transfer_direction }}
                        </th>
                        <th>
                            {{ lang.ammount }}
                        </th>
                        <th>
                            {{ lang.commont }}
                        </th>
                    </tr>
                </thead>
                <tr v-if="!show_data.length">
                    <td colspan="9">
                        <div class="no_data">无数据</div>
                    </td>
                </tr>

                <tr v-for="item, index in show_data" v-if="show_data.length" v-bind:class="{'': index%2}">
                    <td>
                        <div class="td_more_show w_48">
                            <router-link class="blue_ft" :to="{name: 'transaction_detail_view', params: {trx_id: item.trx_id}}">{{ item.trx_id }}</router-link>
                        </div>
                    </td>
                    <td>
                        <div>
                            <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.account}}">{{ item.account }}</router-link>
                        </div>
                    </td>
                    <td>
                        <div>
                            {{ item.name }}
                        </div>
                    </td>
                    <td>
                        <div class="">
                            {{ item.block_time ? time_plus_hours(item.block_time) : 'T' }}
                        </div>
                    </td>
                    <td>
                        <router-link class="blue_ft" :to="{name: 'block_detail_view', params: {block_num: item.block_num}}">{{ item.block_num }}</router-link>&nbsp;
                    </td>
                    <td>
                         <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.actor}}">{{ item.actor + '@' + item.permission }}</router-link>
                    </td>
                    <td>
                        <template v-for="name, index in get_related_accounts(item)" v-if="name">
                            <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: name}}">{{ name }}</router-link> 
                            <span v-if="name && index < get_related_accounts(item).length - 1">-> </span>
                        </template>
                    </td>
                    <td>
                          {{ item.quantity || item.stake ? symblo_change(item.quantity || item.stake) : '' }}
                    </td>
                    <td>
                        <div class="w_100">
                            {{ item.memo }}
                        </div>
                    </td>
                </tr>
            </table>
        </div>
        <div class="get_more_ct" v-if="this.show_data.length">
            <a class="more_action_item get_more_action" v-if="has_more && !on_load" href="javascript:;" @click="next">{{ lang.view_more }}</a>
            <span class="more_action_item gray_info_txt" v-if="has_more && on_load" href="javascript:;">{{ lang.on_loading }}</span>
            <span class="more_action_item gray_info_txt" v-if="!has_more" href="javascript:;">{{ lang.no_more_data }}</span>
        </div>
    </div>
</template>
<script>
import table_nav from '../common/table_nav.vue'
import {
    get_transactions,
    get_action_of_token
} from '../../service/eos_service.js'
import { lang } from '../../data/lang.js'
import { time_plus_hours, symblo_change } from '../utils/utils.js'
import load_fns from '../common/load_fns.js'
import store from '../../data/store.js'
export default {
    data () {
        return {
            on_load: false,
            has_more: true,
            load_timestamp: new Date().getTime(),
            symbol: '',
            page_index: 1,
            page_num: 1,
            page_items_num: 10,
            max_page_num: 7,
            show_data: [],
            page_list: [],
            transaction_names: {
                'vote': lang.data['vote'],
                'unfreeze': lang.data['unfreeze'],
                'claim': lang.data['claim'],
                'transfer': lang.data['transfer'],
                'updatebp': lang.data['updatebp'],
                'newaccount': lang.data['newaccount'],
                'updateauth': lang.data['updateauth'],
            },
            lang: lang.data
        }
    },
    components: {
        table_nav
    },
    computed: {
        is_mobile () {
            return store.state.global_config.is_mobile;
        }
    },
    mounted () {
        this.init();
        this.get_data(1, true);
        this.create_page_list();
    },
    destroyed () {
        this.reset();
    },
    watch: {
        'page_index' () {
            this.create_page_list();
        },
        'page_num' () {
            this.create_page_list();
        },
        '$route.params.symbol' () {
            this.reset();
            this.init();
            this.get_data();
        }
    },
    methods: {
        init () {
            this.page_index = 1;
        },
        reset () {
            this.page_index = 0;
            this.has_more = true;
            this.show_data.splice(0, this.show_data.length);
        },
        get_data(page_index, is_auto){
            this.symbol = this.$route.params.symbol;
            let post_time = this.start_load(true);
            get_action_of_token(this.page_index, 20, this.symbol)
            .then(res => {
                if(!this.diff_data_timestamp(post_time)) return ;
                res.actions = res;
                res.actions.forEach(item => {
                    // item.action_trace = {
                    //     act: item.act || item.trx.transaction.actions[0]
                    // }
                })
                this.show_data.splice(this.show_data.length, 0, ...res.actions);
                this.finish_load();
                if(res.actions.length < 20){
                    this.has_more = false;
                }
            });
        },
        show_action () {

        },
        symblo_change,
        ...load_fns,
        next () {
            this.page_index++;
            this.get_data();
        },
        get_related_accounts (item) {
            let trans = {
                    vote: ['voter', 'bpname'],
                    claim: ['bpname', 'voter'],
                    transfer: ['actor', 'to'],
                    unfreeze: ['bpname', 'actor'],
                    issue: ['actor', 'to'],
                    create: ['actor', 'issuer'],
                    newaccount: ['actor', 'name']
                },
                origin_data = {},
                _from, 
                _to = '', 
                res = [];
            try{
                origin_data = JSON.parse(item.origin_data);
            }catch(e){
                
            }
            if(trans[item['name']]){
                let action_obs = trans[item['name']];
                _from = item[action_obs[0]];
                _to = (origin_data.data ? origin_data.data[action_obs[1]] : '') || item[action_obs[1]];
            }else{
                _from = item['actor'];
                _to = item['to'] || item['account'];
            }
            _from ? res.push(_from) : '';
            _to ? res.push(_to) : '';
            return res;
        },
        get_action_ob (item) {

            if(item.authorization){
                return item;
            }
            if(item.act){
                return item.act;
            }
            if(item.trx){
                return item.trx.transaction.actions[0];
            }
            return item;
        }
    }
}
</script>



